//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
// 

#include "Source.h"

Define_Module(Source);

void Source::initialize()
{
	sumTime = 0;
	countTime = 0;
	lastTime = 0;
    data = new cMessage("DATA", DATA);
    send(data, "outGate");
}

void Source::handleMessage(cMessage *msg)
{
    if(msg->getKind() == DATA){
    	sumTime = sumTime + simTime() - lastTime;
    	lastTime = simTime();
    	countTime ++;
    	send(msg, "outGate");
    	countOfAllMessages++;
    	// Vypis do prostredi simulace:
    	//EV << "Name: " << msg->getSenderGate()->getOwnerModule()->getFullName() << endl;
    	Repeater *r = (Repeater *)msg->getSenderGate()->getOwner();
    } else {
    	// Chyba
    }
}

void Source::finish(){
	EV << "Prumerny cas zpozdeni: " <<  sumTime / countTime << "s" << endl;
	EV << "Pocet vsech message: " << countOfAllMessages << endl;
	delete data;
}

int Source::countOfAllMessages;
